> module Main where
> import Control.Concurrent (forkIO)
> import Control.Monad (forever) 
> import Control.Monad.IO.Class (liftIO)

> import Data.ByteString.UTF8 (fromString,toString)
> import Network.Connection

> import Graphics.UI.Gtk

Verbindungsdaten:

> theCon ctx =  connectTo ctx $ ConnectionParams
>   { connectionHostname  = "kueken.chickenkiller.com"
>   , connectionPort      = 4242
>   , connectionUseSecure = Nothing
>   , connectionUseSocks  = Nothing
>   } 

Verbindung aufbauen:

> main = do
>   ctx <- initConnectionContext
>   con <- theCon ctx

Textbuffer, für die Nachrichten im GUI.

>   buf <- textBufferNew Nothing

Gui initialisieren.

>   initGUI

Empfangen zeilenweise über die Verbindung 

>   forkIO $ forever$ do
>     line <- connectionGetLine  1024 con 
>     postGUIAsync $do
>       iter <- textBufferGetIterAtLine buf 0
>       textBufferInsert buf iter ("\n")
>       textBufferInsertByteString buf iter line

Senden der Anwendereingaben:

>   display <- entryNew
>   display `on` entryActivate $ do
>     s <- (entryGetText display):: IO String
>     connectionPut con (fromString s)
>     connectionPut con (fromString " \n")
>     set display [ entryText := "" ] 

Gesamt GUI.

>   window <- windowNew
>   box <- vBoxNew False 5
>   textV <- textViewNew
>   scrwin <- scrolledWindowNew Nothing Nothing
>   scrolledWindowAddWithViewport scrwin textV
>   set textV [textViewEditable := False, textViewBuffer := buf ] 
>   boxPackStart box display PackNatural 0
>   boxPackStart box scrwin PackGrow 0
>   set window [ containerChild := box
>              , windowDefaultWidth := 800
>              , windowDefaultHeight := 600
>              ]
>   window `on` deleteEvent $ do
>     liftIO mainQuit
>     return False  

>   widgetShowAll window
>   mainGUI


